SoW-2020-0002: Trace Hit Counters: trigger error reporting integration
[lttng-tools.git] / tests / regression / tools / trigger / test_add_trigger_cli
diff --git a/tests/regression/tools/trigger/test_add_trigger_cli b/tests/regression/tools/trigger/test_add_trigger_cli
new file mode 100755 (executable)
index 0000000..467d942
--- /dev/null
@@ -0,0 +1,413 @@
+#!/bin/bash
+#
+# Copyright (C) - 2020 EfficiOS, inc
+#
+# This library is free software; you can redistribute it and/or modify it under
+# the terms of the GNU Lesser General Public License as published by the Free
+# Software Foundation; version 2.1 of the License.
+#
+# This library is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
+# details.
+#
+# You should have received a copy of the GNU Lesser General Public License
+# along with this library; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA
+
+# Test the `lttng add-trigger` command line interface.
+
+CURDIR="$(dirname "$0")"
+TESTDIR="$CURDIR/../../.."
+
+# shellcheck source=../../../utils/utils.sh
+source "$TESTDIR/utils/utils.sh"
+
+plan_tests 216
+
+FULL_LTTNG_BIN="${TESTDIR}/../src/bin/lttng/${LTTNG_BIN}"
+
+# shellcheck disable=SC2119
+start_lttng_sessiond_notap
+
+tmp_stdout=$(mktemp -t test_parse_cli_trigger_stdout.XXXXXX)
+tmp_stderr=$(mktemp -t test_parse_cli_trigger_stderr.XXXXXX)
+uprobe_elf_binary="${TESTDIR}/utils/testapp/userspace-probe-elf-binary/.libs/userspace-probe-elf-binary"
+
+if [ "$(id -u)" == "0" ]; then
+       ist_root=1
+else
+       ist_root=0
+fi
+
+function test_success ()
+{
+       local test_name="$1"
+       shift
+
+       diag "${FULL_LTTNG_BIN} add-trigger $*"
+       "${FULL_LTTNG_BIN}" add-trigger "$@" > "${tmp_stdout}" 2> "${tmp_stderr}"
+       ok $? "${test_name}: exit code is 0"
+
+       diff -u "${tmp_stdout}" <(echo "Trigger registered successfully.")
+       ok $? "${test_name}: expected stdout"
+
+       diff -u "${tmp_stderr}" /dev/null
+       ok $? "${test_name}: expected stderr"
+}
+
+function test_failure ()
+{
+       local test_name="$1"
+       local error_msg="$2"
+
+       shift 2
+
+       diag "${FULL_LTTNG_BIN} add-trigger $*"
+       "${FULL_LTTNG_BIN}" add-trigger "$@" > "${tmp_stdout}" 2> "${tmp_stderr}"
+       isnt $? 0 "${test_name}: exit code is not 0"
+
+       diff -u "${tmp_stdout}" /dev/null
+       ok $? "${test_name}: expected stdout"
+
+       diff -u "${tmp_stderr}" <(echo "${error_msg}")
+       ok $? "${test_name}: expected stderr"
+}
+
+# top-level options
+test_success "explicit id" \
+       --id hohoho \
+       --condition on-event some-event-id -u \
+       --action notify
+
+# `--condition on-event` successes
+test_success "--condition on-event some-event -u" \
+       --condition on-event some-event -u \
+       --action notify
+
+test_success "--condition on-event -a -u" \
+       --condition on-event -a -u \
+       --action notify
+
+test_success "--fire-once-after" \
+       --condition on-event -u test-fire-once-after \
+       --action notify \
+       --fire-once-after=55
+
+test_success "--fire-every" \
+       --condition on-event -u test-fire-every \
+       --action notify \
+       --fire-every=55
+
+skip $ist_root "non-root user: skipping kprobe tests" 9 || {
+       test_success "--condition on-event probe by symbol" \
+               --condition on-event -k --probe=lttng_channel_enable my_channel_enable \
+               --action notify
+
+       channel_enable_addr=$(grep ' t lttng_channel_enable\s\[lttng_tracer\]$' /proc/kallsyms | cut -f 1 -d ' ')
+       channel_disable_addr=$(grep ' t lttng_channel_disable\s\[lttng_tracer\]$' /proc/kallsyms | cut -f 1 -d ' ')
+
+       # We need to find a valid offset.
+       base_symbol=""
+       offset=0
+       if [[ 0x$channel_enable_addr -lt 0x$channel_disable_addr ]]; then
+               base_symbol="lttng_channel_enable"
+               offset=$(( 0x$channel_disable_addr - 0x$channel_enable_addr ))
+       else
+               base_symbol="lttng_channel_disable"
+               offset=$(( 0x$channel_enable_addr - 0x$channel_disable_addr ))
+       fi
+
+       offset_hex="0x$(printf '%x' $offset)"
+
+       test_success "--condition on-event probe by symbol with offset" \
+               --condition on-event -k --probe="${base_symbol}+${offset_hex}" my_$base_symbol \
+               --action notify
+
+       test_success "--condition on-event probe by address" \
+               --condition on-event -k "--probe=0x${channel_enable_addr}" my_channel_enable \
+               --action notify
+}
+
+skip $ist_root "non-root user: skipping uprobe tests" 6 || {
+       test_success "--condition on-event uprobe" \
+               --condition on-event -k --userspace-probe=${uprobe_elf_binary}:test_function ma-probe \
+               --action notify
+
+       test_success "--condition on-event uprobe with elf prefix" \
+               --condition on-event -k --userspace-probe=elf:${uprobe_elf_binary}:test_function ma-probe-2 \
+               --action notify
+}
+
+skip $ist_root "non-root user: skipping syscall tests" 9 || {
+       test_success "--condition on-event syscall" \
+               --condition on-event -k --syscall open \
+               --action notify
+
+       test_success "--condition on-event syscall -a" \
+               --condition on-event -k --syscall -a \
+               --action notify
+
+       test_success "--condition on-event syscall with filter" \
+               --condition on-event -k --syscall --filter 'a > 2' open \
+               --action notify
+}
+
+# `--action notify` successes
+test_success "--action notify" \
+       --condition on-event some-event-notify -u \
+       --action notify
+
+test_success "--action notify --capture foo" \
+       --condition on-event some-event-notify-foo -u \
+       --capture foo --action notify
+
+test_success "--action notify --capture foo[2]" \
+       --condition on-event some-event-notify-foo2 -u \
+       --capture 'foo[2]' --action notify
+
+test_success '--action notify --capture $ctx.foo' \
+       --condition on-event some-event-notify-ctx-foo -u \
+       --capture '$ctx.foo' --action notify
+
+test_success '--action notify --capture $ctx.foo[2]' \
+       --condition on-event some-event-notify-ctx-foo2 -u \
+       --capture '$ctx.foo[2]' --action notify
+
+test_success '--action notify --capture $app.prov:type' \
+       --condition on-event some-event-notify-app-prov-type -u \
+       --capture '$app.prov:type' --action notify
+
+test_success '--action notify --capture $app.prov:type[2]' \
+       --condition on-event some-event-notify-app-prov-type-2 -u \
+       --capture '$app.prov:type[2]' --action notify
+
+test_success '--action notify multiple captures' \
+       --condition on-event some-event-notify-multiple-captures -u \
+       --capture foo --capture '$app.hello:world' --action notify
+
+# `--action start-session` successes
+test_success "--action start-session" \
+       --condition on-event some-event-start-session -u \
+       --action start-session ze-session
+
+# `--action stop-session` successes
+test_success "--action stop-session foo" \
+       --condition on-event some-event-stop-session -u \
+       --action stop-session ze-session
+
+# `--action rotate-session` successes
+test_success "--action rotate-session foo" \
+       --condition on-event some-event-rotate-session -u \
+       --action rotate-session ze-session
+
+# `--action snapshot-session` successes
+test_success "--action snapshot-session foo" \
+       --condition on-event some-event-snapshot-session -u \
+       --action snapshot-session ze-session
+
+test_success "--action snapshot-session with file URI" \
+       --condition on-event some-event-snapshot-session2 -u \
+       --action snapshot-session ze-session /hello
+
+test_success "--action snapshot-session with net URI" \
+       --condition on-event some-event-snapshot-session3 -u \
+       --action snapshot-session ze-session net://1.2.3.4
+
+test_success "--action snapshot-session with ctrl/data URIs" \
+       --condition on-event some-event-snapshot-session4 -u \
+       --action snapshot-session ze-session --ctrl-url=tcp://1.2.3.4:1234 --data-url=tcp://1.2.3.4:1235
+
+# top-level failures
+test_failure "no args" "Error: Missing --condition."
+
+test_failure "unknown option" \
+       "Error: Unknown option \`--hello\`" \
+       --hello
+
+test_failure "missing --action" \
+       "Error: Need at least one --action." \
+       --condition on-event hello -u
+
+test_failure "two --condition" \
+       "Error: A --condition was already given." \
+       --condition on-event aaa -u \
+       --condition on-event bbb -u \
+       --action notify
+
+test_failure "missing argument to --id" \
+       "Error: While parsing argument #1 (\`--id\`): Missing required argument for option \`--id\`" \
+       --id
+
+for cmd in fire-once-after fire-every; do
+       test_failure "missing argument to --${cmd}" \
+               "Error: While parsing argument #1 (\`--${cmd}\`): Missing required argument for option \`--${cmd}\`" \
+               --condition on-event -u -a --action notify \
+               --${cmd}
+
+       test_failure "invalid argument to --${cmd}: non-digit character" \
+               "Error: Failed to parse \`123bob\` as an integer." \
+               --condition on-event -u -a --action notify \
+               --${cmd} 123bob
+
+       test_failure "invalid argument to --${cmd}: empty string" \
+               "Error: Failed to parse \`\` as an integer." \
+               --condition on-event -u -a --action notify \
+               --${cmd} ""
+done
+
+# `--condition` failures
+test_failure "missing args after --condition" \
+       "Error: Missing condition name." \
+       --condition
+test_failure "unknown --condition" \
+       "Error: Unknown condition name: zoofest" \
+       --condition zoofest
+
+# `--condition on-event` failures
+test_failure "missing args after --condition on-event" \
+       "Error: Need to provide either a tracepoint name or -a/--all." \
+       --condition on-event
+test_failure "missing domain in --condition on-event" \
+       "Error: Please specify a domain (-k/-u/-j)." \
+       --condition on-event -a
+test_failure "extra args after --condition on-event" \
+       "Error: Unexpected argument: bozo" \
+       --condition on-event foo -u bozo
+test_failure "--condition on-event: --all with --probe" \
+       "Error: Can't use -a/--all with event rule of type probe." \
+       --condition on-event --probe=do_sys_open --all
+test_failure "--condition on-event: missing tracepoint name with --probe" \
+       "Error: Need to provide either a tracepoint name or -a/--all." \
+       --condition on-event -k --probe do_sys_open
+
+test_failure "--condition on-event: missing tracepoint name with --userspace-probe" \
+       "Error: Need to provide either a tracepoint name or -a/--all." \
+       --condition on-event -k --userspace-probe=${uprobe_elf_binary}:test_function
+
+test_failure "--condition on-event: extra argument with --userspace-probe" \
+       "Error: Unexpected argument: world" \
+       --condition on-event -k --userspace-probe=${uprobe_elf_binary}:test_failure hello world
+
+test_failure "--condition on-event: missing tracepoint name with --syscall" \
+       "Error: Need to provide either a tracepoint name or -a/--all." \
+       --condition on-event -k --syscall
+
+test_failure "--condition on-event: extra argument with --syscall" \
+       "Error: Unexpected argument: open" \
+       --condition on-event -k --syscall open open
+
+test_failure "--condition on-event: both -a and a tracepoint name with --syscall" \
+       "Error: Can't provide a tracepoint name with -a/--all." \
+       --condition on-event -k --syscall -a open
+
+test_failure "--condition on-event --capture: missing argument (end of arg list)" \
+       'Error: While parsing argument #3 (`--capture`): Missing required argument for option `--capture`' \
+       --action notify \
+       --condition on-event -u -a --capture
+
+test_failure "--condition on-event --capture: missing argument (before another option)" \
+       'Error: While parsing expression `--action`: Unary operators are not allowed in capture expressions.' \
+       --condition on-event -u -a --capture \
+       --action notify \
+
+test_failure "--condition on-event --capture: binary operator" \
+       'Error: While parsing expression `foo == 2`: Binary operators are not allowed in capture expressions.' \
+       --condition on-event -u -a \
+       --capture 'foo == 2' --action notify
+
+test_failure "--condition on-event --capture: unary operator" \
+       'Error: While parsing expression `!foo`: Unary operators are not allowed in capture expressions.' \
+       --condition on-event -u -a \
+       --capture '!foo' --action notify
+
+test_failure "--condition on-event --capture: logical operator" \
+       'Error: While parsing expression `foo || bar`: Logical operators are not allowed in capture expressions.' \
+       --condition on-event -u -a \
+       --capture 'foo || bar' --action notify
+
+test_failure "--condition on-event --capture: accessing a sub-field" \
+       'Error: While parsing expression `foo.bar`: Capturing subfields is not supported.' \
+       --condition on-event -u -a \
+       --capture 'foo.bar' --action notify
+
+test_failure "--condition on-event --capture: accessing the sub-field of an array element" \
+       'Error: While parsing expression `foo[3].bar`: Capturing subfields is not supported.' \
+       --condition on-event -u -a \
+       --capture 'foo[3].bar' --action notify
+
+test_failure "--condition on-event --capture: missing colon in app-specific context field" \
+       'Invalid app-specific context field name: missing colon in `foo`.' \
+       --condition on-event -u -a \
+       --capture '$app.foo' --action notify
+
+test_failure "--condition on-event --capture: missing colon in app-specific context field" \
+       'Invalid app-specific context field name: missing type name after colon in `foo:`.' \
+       --condition on-event -u -a \
+       --capture '$app.foo:' --action notify
+
+# `--action` failures
+test_failure "missing args after --action" \
+       "Error: Missing action name." \
+       --condition on-event -u -a \
+       --action
+
+# `--action notify` failures
+test_failure "extra arg after --action notify" \
+       "Error: Unexpected argument \`bob\`." \
+       --condition on-event -u -a \
+       --action notify bob
+
+# `--action start-session` failures
+test_failure "missing arg after --action start-session" \
+       "Error: Missing session name." \
+       --condition on-event some-event-start-session -u \
+       --action start-session
+test_failure "extra arg after --action start-session" \
+       "Error: Unexpected argument \`bob\`." \
+       --condition on-event some-event-start-session -u \
+       --action start-session ze-session bob
+
+# `--action stop-session` failures
+test_failure "missing arg after --action stop-session" \
+       "Error: Missing session name." \
+       --condition on-event some-event-stop-session -u \
+       --action stop-session
+test_failure "extra arg after --action stop-session" \
+       "Error: Unexpected argument \`bob\`." \
+       --condition on-event some-event-stop-session -u \
+       --action stop-session ze-session bob
+
+# `--action rotate-session` failures
+test_failure "missing arg after --action rotate-session" \
+       "Error: Missing session name." \
+       --condition on-event some-event-rotate-session -u \
+       --action rotate-session
+test_failure "extra arg after --action rotate-session" \
+       "Error: Unexpected argument \`bob\`." \
+       --condition on-event some-event-rotate-session -u \
+       --action rotate-session ze-session bob
+
+# `--action snapshot-session` failures
+test_failure "missing arg after --action snapshot-session" \
+       "Error: Missing session name." \
+       --condition on-event some-event-snapshot-session -u \
+       --action snapshot-session
+test_failure "extra arg after --action snapshot-session" \
+       "Error: Unexpected argument \`bob\`." \
+       --condition on-event some-event-snapshot-session -u \
+       --action snapshot-session ze-session /dest bob
+test_failure "snapshot-session action, --max-size without destination" \
+       "Error: Can't provide a snapshot output max size without a snapshot output destination." \
+       --condition on-event some-event-snapshot-session -u \
+       --action snapshot-session ze-session --max-size 10M
+test_failure "snapshot-session action, --name without destination" \
+       "Error: Can't provide a snapshot output name without a snapshot output destination." \
+       --condition on-event some-event-snapshot-session -u \
+       --action snapshot-session ze-session --name hallo
+
+
+# Cleanup
+stop_lttng_sessiond_notap
+rm -f "${tmp_stdout}"
+rm -f "${tmp_stderr}"
This page took 0.027607 seconds and 5 git commands to generate.